diff --git a/SHADE_Managed/src/Math/Vector3.cxx b/SHADE_Managed/src/Math/Vector3.cxx
index 26ff5a72..adbb4d3a 100644
--- a/SHADE_Managed/src/Math/Vector3.cxx
+++ b/SHADE_Managed/src/Math/Vector3.cxx
@@ -11,6 +11,7 @@ Copyright (C) 2021 DigiPen Institute of Technology.
 Reproduction or disclosure of this file or its contents without the prior written consent 
 of DigiPen Institute of Technology is prohibited.
 *//*************************************************************************************/
+
 // Precompiled Headers
 #include "SHpch.h"
 // Primary Header
@@ -26,13 +27,13 @@ namespace SHADE
     /*---------------------------------------------------------------------------------*/
     /* Constructors                                                                    */
     /*---------------------------------------------------------------------------------*/
-    Vector3::Vector3(double _x) 
-    : Vector3 {_x, 0.0, 0.0}
+    Vector3::Vector3(float _x) 
+    : Vector3 {_x, 0.0f, 0.0f}
     {}
-    Vector3::Vector3(double _x, double _y)
-    : Vector3 {_x, _y, 0.0}
+    Vector3::Vector3(float _x, float _y)
+    : Vector3 {_x, _y, 0.0f}
     {}
-    Vector3::Vector3(double _x, double _y, double _z)
+    Vector3::Vector3(float _x, float _y, float _z)
     : x { _x }
     , y { _y }
     , z { _z }
@@ -54,22 +55,22 @@ namespace SHADE
         return *this / GetSqrMagnitude();
     }
 
-    double Vector3::GetMagnitude()
+    float Vector3::GetMagnitude()
     {
         return sqrt(x * x + y * y + z * z);
     }
 
-    double Vector3::GetSqrMagnitude()
+    float Vector3::GetSqrMagnitude()
     {
         return x * x + y * y + z * z;
     }
 
-    double Vector3::Angle2DFromRightRadians()
+    float Vector3::Angle2DFromRightRadians()
     {
         return atan2(y, x);
     }
 
-    double Vector3::Angle2DFromRightDegrees()
+    float Vector3::Angle2DFromRightDegrees()
     {
         return Math::RadiansToDegrees(Angle2DFromRightRadians());
     }
@@ -79,7 +80,7 @@ namespace SHADE
         return IsNearPoint(point, Math::Epsilon);
     }
 
-    bool Vector3::IsNearPoint(Vector3 point, double tolerance)
+    bool Vector3::IsNearPoint(Vector3 point, float tolerance)
     {
         return (*this - point).GetSqrMagnitude() < (tolerance * tolerance);
     }
@@ -121,7 +122,7 @@ namespace SHADE
     {
         return IsNear(lhs, rhs, Math::Epsilon);
     }
-    bool Vector3::IsNear(Vector3 lhs, Vector3 rhs, double tolerance)
+    bool Vector3::IsNear(Vector3 lhs, Vector3 rhs, float tolerance)
     {
         return (std::abs(lhs.x) - std::abs(rhs.x)) < tolerance
                &&
@@ -129,7 +130,7 @@ namespace SHADE
                &&
                (std::abs(lhs.z) - std::abs(rhs.z)) < tolerance;
     }
-    double Vector3::Dot(Vector3 lhs, Vector3 rhs)
+    float Vector3::Dot(Vector3 lhs, Vector3 rhs)
     {
         return lhs.x * rhs.x + lhs.y * rhs.y + lhs.z * rhs.z;
     }
@@ -145,12 +146,12 @@ namespace SHADE
     }
     Vector3 Vector3::Reflect(Vector3 vec, Vector3 normal)
     {
-        return vec - (Project(vec, normal.GetNormalised()) * 2.0);
+        return vec - (Project(vec, normal.GetNormalised()) * 2.0f);
     }
-    Vector3 Vector3::RotateRadians(Vector3 vec, double radians)
+    Vector3 Vector3::RotateRadians(Vector3 vec, float radians)
     {
-        const double SINE   = sin(radians);
-        const double COSINE = cos(radians);
+        const float SINE   = sin(radians);
+        const float COSINE = cos(radians);
 
         return Vector3
         (
@@ -159,15 +160,15 @@ namespace SHADE
             vec.z
         );
     }
-    Vector3 Vector3::RotateDegrees(Vector3 vec, double degrees)
+    Vector3 Vector3::RotateDegrees(Vector3 vec, float degrees)
     {
         return RotateRadians(vec, Math::DegreesToRadians(degrees));
     }
     Vector3 Vector3::Min(Vector3 lhs, Vector3 rhs)
     {
-        double lx = lhs.x, rx = rhs.x;
-        double ly = lhs.y, ry = rhs.y;
-        double lz = lhs.z, rz = rhs.z;
+        float lx = lhs.x, rx = rhs.x;
+        float ly = lhs.y, ry = rhs.y;
+        float lz = lhs.z, rz = rhs.z;
 
         return Vector3(std::min(lx, rx),
                        std::min(ly, ry),
@@ -175,23 +176,23 @@ namespace SHADE
     }
     Vector3 Vector3::Max(Vector3 lhs, Vector3 rhs)
     {
-        double lx = lhs.x, rx = rhs.x;
-        double ly = lhs.y, ry = rhs.y;
-        double lz = lhs.z, rz = rhs.z;
+        float lx = lhs.x, rx = rhs.x;
+        float ly = lhs.y, ry = rhs.y;
+        float lz = lhs.z, rz = rhs.z;
 
         return Vector3(std::max(lx, rx),
                        std::max(ly, ry),
                        std::max(lz, rz));  
     }
-    Vector3 Vector3::Lerp(Vector3 a, Vector3 b, double t)
+    Vector3 Vector3::Lerp(Vector3 a, Vector3 b, float t)
     {
-        return LerpUnclamped(a, b, std::clamp(t, 0.0, 1.0));
+        return LerpUnclamped(a, b, std::clamp(t, 0.0f, 1.0f));
     }
-    Vector3 Vector3::LerpUnclamped(Vector3 a, Vector3 b, double t)
+    Vector3 Vector3::LerpUnclamped(Vector3 a, Vector3 b, float t)
     {
         return a + ((b - a) * t);
     }
-    Vector3 Vector3::MoveTowards(Vector3 current, Vector3 target, double maxDistanceDelta)
+    Vector3 Vector3::MoveTowards(Vector3 current, Vector3 target, float maxDistanceDelta)
     {
         // Ignore if it is exactly on the same point
         if (current == target)
@@ -203,7 +204,7 @@ namespace SHADE
 
         // Check if check if is behind or ahead of target
         Vector3 DIFF = target - newPos;
-        if (Dot(DELTA, DIFF) < 0.0)
+        if (Dot(DELTA, DIFF) < 0.0f)
         {
             newPos = target;
         }
@@ -236,7 +237,7 @@ namespace SHADE
             lhs.z * rhs.z
         );
     }
-    Vector3 Vector3::operator*(Vector3 lhs, double rhs)
+    Vector3 Vector3::operator*(Vector3 lhs, float rhs)
     {
         return Vector3
         (
@@ -245,7 +246,7 @@ namespace SHADE
             lhs.z * rhs
         );
     }
-    Vector3 Vector3::operator/(Vector3 lhs, double rhs)
+    Vector3 Vector3::operator/(Vector3 lhs, float rhs)
     {
         return Vector3
         (
diff --git a/SHADE_Managed/src/Math/Vector3.hxx b/SHADE_Managed/src/Math/Vector3.hxx
index e6cdc7d4..70cff88f 100644
--- a/SHADE_Managed/src/Math/Vector3.hxx
+++ b/SHADE_Managed/src/Math/Vector3.hxx
@@ -11,6 +11,7 @@ Copyright (C) 2021 DigiPen Institute of Technology.
 Reproduction or disclosure of this file or its contents without the prior written consent 
 of DigiPen Institute of Technology is prohibited.
 *//*************************************************************************************/
+
 #pragma once
 
 // Standard Libraries
@@ -21,8 +22,8 @@ of DigiPen Institute of Technology is prohibited.
 namespace SHADE
 {
     ///<summary>
-    /// CLR version of the the PlushieEngine's Vector3 class that represents a 
-    /// 3-Dimensional Vector. Designed to closely match Unity's Vector3 struct.
+    /// CLR version of SHADE Engine's Vector3 class that represents a 3-Dimensional Vector.
+    /// Designed to closely match Unity's Vector3 struct.
     /// </summary>
     [System::Runtime::InteropServices::StructLayout(System::Runtime::InteropServices::LayoutKind::Sequential)]
     public value struct Vector3 : public System::IEquatable<Vector3>
@@ -35,49 +36,49 @@ namespace SHADE
         ///<summary>
         /// Shorthand for writing Vector3(0, 0, -1).
         ///</summary>
-        static initonly Vector3 Back = Vector3(0.0, 0.0, -1.0);
+        static initonly Vector3 Back = Vector3(0.0f, 0.0f, -1.0f);
         ///<summary>
         /// Shorthand for writing Vector3(0, -1, 0).
         ///</summary>
-        static initonly Vector3 Down = Vector3(0.0, -1.0, 0.0);
+        static initonly Vector3 Down = Vector3(0.0f, -1.0f, 0.0f);
         ///<summary>
         /// Shorthand for writing Vector3(0, 0, 1).
         ///</summary>
-        static initonly Vector3 Forward = Vector3(0.0, 0.0, 1.0);
+        static initonly Vector3 Forward = Vector3(0.0f, 0.0f, 1.0f);
         ///<summary>
         /// Shorthand for writing Vector3(-1, 0, 0).
         ///</summary>
-        static initonly Vector3 Left = Vector3(-1.0, 0.0, 0.0);
+        static initonly Vector3 Left = Vector3(-1.0f, 0.0f, 0.0f);
         ///<summary>
-        /// Shorthand for writing Vector3(double.NegativeInfinity, 
-        /// double.NegativeInfinity, double.NegativeInfinity).
+        /// Shorthand for writing Vector3(float.NegativeInfinity, 
+        /// float.NegativeInfinity, float.NegativeInfinity).
         ///</summary>
-        static initonly Vector3 NegativeInfinity = Vector3(std::numeric_limits<double>::lowest(),
-                                                               std::numeric_limits<double>::lowest(), 
-                                                               std::numeric_limits<double>::lowest());
+        static initonly Vector3 NegativeInfinity = Vector3(std::numeric_limits<float>::lowest(),
+                                                               std::numeric_limits<float>::lowest(), 
+                                                               std::numeric_limits<float>::lowest());
         ///<summary>
         /// Shorthand for writing Vector3(1, 1, 1).
         ///</summary>
-        static initonly Vector3 One = Vector3(1.0, 1.0, 1.0);
+        static initonly Vector3 One = Vector3(1.0f, 1.0f, 1.0f);
         ///<summary>
-        /// Shorthand for writing Vector3(double.PositiveInfinity, 
-        /// double.PositiveInfinity, double.PositiveInfinity).
+        /// Shorthand for writing Vector3(float.PositiveInfinity, 
+        /// float.PositiveInfinity, float.PositiveInfinity).
         ///</summary>
-        static initonly Vector3 PositiveInfinity = Vector3(std::numeric_limits<double>::max(),
-                                                               std::numeric_limits<double>::max(), 
-                                                               std::numeric_limits<double>::max());
+        static initonly Vector3 PositiveInfinity = Vector3(std::numeric_limits<float>::max(),
+                                                               std::numeric_limits<float>::max(), 
+                                                               std::numeric_limits<float>::max());
         ///<summary>
         /// Shorthand for writing Vector3(1, 0, 0).
         ///</summary>
-        static initonly Vector3 Right = Vector3(1.0, 0.0, 0.0);
+        static initonly Vector3 Right = Vector3(1.0f, 0.0f, 0.0f);
         ///<summary>
         /// Shorthand for writing Vector3(0, 1, 0).
         ///</summary>
-        static initonly Vector3 Up = Vector3(0.0, 1.0, 0.0);
+        static initonly Vector3 Up = Vector3(0.0f, 1.0f, 0.0f);
         ///<summary>
         /// Shorthand for writing Vector3(0, 0, 0).
         ///</summary>        
-        static initonly Vector3 Zero = Vector3(0.0, 0.0, 0.0);
+        static initonly Vector3 Zero = Vector3(0.0f, 0.0f, 0.0f);
         #pragma endregion
 
         /*-----------------------------------------------------------------------------*/
@@ -86,39 +87,39 @@ namespace SHADE
         ///<summary>
         /// X-component of the Vector3.
         ///</summary>
-        double x;
+        float x;
         ///<summary>
         /// Y-component of the Vector3.
         ///</summary>
-        double y;
+        float y;
         ///<summary>
         /// Z-component of the Vector3.
         ///</summary>
-        double z;
+        float z;
 
         /*-----------------------------------------------------------------------------*/
         /* Constructors                                                                */
         /*-----------------------------------------------------------------------------*/
         /// <summary>
         /// Constructor to construct a Vector3 with the specified components with the 
-        /// Y and Z-component set to 0.0.
+        /// Y and Z-component set to 0.0f.
         /// </summary>
         /// <param name="_x">X-coordinate to set.</param>
-        Vector3(double _x);
+        Vector3(float _x);
         /// <summary>
         /// Constructor to construct a Vector3 with the specified components with the 
-        /// Z-component set to 0.0.
+        /// Z-component set to 0.0f.
         /// </summary>
         /// <param name="_x">X-coordinate to set.</param>
         /// <param name="_y">Y-coordinate to set.</param>
-        Vector3(double _x, double _y);
+        Vector3(float _x, float _y);
         /// <summary>
         /// Constructor to construct a Vector3 with the specified components.
         /// </summary>
         /// <param name="_x">X-coordinate to set.</param>
         /// <param name="_y">Y-coordinate to set.</param>
         /// <param name="_z">Z-coordinate to set.</param>
-        Vector3(double _x, double _y, double _z);
+        Vector3(float _x, float _y, float _z);
         /// <summary>
         /// Conversion constructor to construct a Vector3 using a Vector2.
         /// </summary>
@@ -148,24 +149,24 @@ namespace SHADE
         /// need the precise magnitude, consider using GetSqrMagnitude() instead.
         /// </summary>
         /// <returns>Returns the length of this Vector3.</returns>
-        double GetMagnitude();
+        float GetMagnitude();
         /// <summary>
         /// Calculates and returns the squared magnitude of this Vector3.
         /// </summary>
         /// <returns>Returns the squared length of this Vector3.</returns>
-        double GetSqrMagnitude();
+        float GetSqrMagnitude();
         /// <summary>
         /// Calculates and returns the angle of this vector from the right vector. This 
         /// function returns values between -Math.PI and Math.PI.
         /// </summary>
         /// <returns>Returns the angle of this vector from the right vector in radians.</returns>
-        double Angle2DFromRightRadians();
+        float Angle2DFromRightRadians();
         /// <summary>
         /// Calculates and returns the angle of this vector from the right vector. This 
-        /// function returns values between -180.0 and 180.0.
+        /// function returns values between -180.0f and 180.0f.
         /// </summary>
         /// <returns>Returns the angle of this vector from the right vector in degrees.</returns>
-        double Angle2DFromRightDegrees();
+        float Angle2DFromRightDegrees();
         /// <summary>
         /// Checks if a specified point is near this Vector3 that represents a point with
         /// a tolerance value of PLS_EPSILON.
@@ -187,7 +188,7 @@ namespace SHADE
         /// True if this Vector3 representing a point and the specified point are within
         /// the range of the specified tolerance. False otherwise.
         /// </returns>
-        bool IsNearPoint(Vector3 point, double tolerance);
+        bool IsNearPoint(Vector3 point, float tolerance);
 
         /*-----------------------------------------------------------------------------*/
         /* IEquatable                                                                  */
@@ -207,12 +208,12 @@ namespace SHADE
         /// </summary>
         /// <param name="o">The unboxed object to compare with.</param>
         /// <returns>True if both objects are the same.</returns>
-        bool Equals(Object^ o) override; 
+        bool Equals(Object^ o) override;
         /// <summary>
         /// Gets a unique hash for this object.
         /// </summary>
         /// <returns>Unique hash for this object.</returns>
-        int  GetHashCode() override;         
+        int  GetHashCode() override;
 
         /*-----------------------------------------------------------------------------*/
         /* Static Functions                                                            */
@@ -235,14 +236,14 @@ namespace SHADE
         /// <returns>
         /// True if the two Vector3s are within the tolerance value specified
         /// </returns>
-        static bool IsNear(Vector3 lhs, Vector3 rhs, double tolerance);
+        static bool IsNear(Vector3 lhs, Vector3 rhs, float tolerance);
         /// <summary>
         /// Computes and returns the dot product of 2 specified Vector3s.
         /// </summary>
         /// <param name="lhs">Vector3 to calculate dot product with.</param>
         /// <param name="rhs">Another Vector3 to calculate dot product with.</param>
         /// <returns>Scalar value representing the dot product of the two Vector3s.</returns>
-        static double Dot(Vector3 lhs, Vector3 rhs);
+        static float Dot(Vector3 lhs, Vector3 rhs);
         /// <summary>
         /// Computes and returns the cross product of 2 specified Vector3s.
         /// </summary>
@@ -273,7 +274,7 @@ namespace SHADE
         /// Angle to rotate the vector by in an anti-clockwise direction in radians.
         /// </param>
         /// <returns>The Vector3 that represents the rotated vector.</returns>
-        static Vector3 RotateRadians(Vector3 vec, double radians);
+        static Vector3 RotateRadians(Vector3 vec, float radians);
         /// <summary>
         /// Rotates a Vector3 on the Z-axis by a specified angle in an anti-clockwise 
         /// direction.
@@ -283,7 +284,7 @@ namespace SHADE
         /// Angle to rotate the vector by in an anti-clockwise direction in degrees.
         /// </param>
         /// <returns>The Vector3 that represents the rotated vector.</returns>
-        static Vector3 RotateDegrees(Vector3 vec, double degrees);
+        static Vector3 RotateDegrees(Vector3 vec, float degrees);
         /// <summary>
         /// Computes and returns a Vector3 that is made from the smallest components of 
         /// the two specified Vector3s.
@@ -311,25 +312,25 @@ namespace SHADE
         /// This is most commonly used to find a point some fraction of the way along a 
         /// line between two endpoints.
         /// </summary>
-        /// <param name="a">The start Vector3, returned when t = 0.0.</param>
-        /// <param name="b">The end Vector3, returned when t = 1.0.</param>
+        /// <param name="a">The start Vector3, returned when t = 0.0f.</param>
+        /// <param name="b">The end Vector3, returned when t = 1.0f.</param>
         /// <param name="t">
         /// Value used to interpolate between a and b which is clamped to
         /// the range[0, 1].
         /// </param>
         /// <returns>The interpolated Vector3.</returns>
-        static Vector3 Lerp(Vector3 a, Vector3 b, double t);        
+        static Vector3 Lerp(Vector3 a, Vector3 b, float t);        
         /// <summary>
         /// Linearly interpolates between two specified points. 
         /// This is most commonly used to find a point some fraction of the way along a 
         /// line between two endpoints.
         /// Unlike Lerp(), t is not clamped to a range at all.
         /// </summary>
-        /// <param name="a">The start Vector3, returned when t = 0.0.</param>
-        /// <param name="b">The end Vector3, returned when t = 1.0.</param>
+        /// <param name="a">The start Vector3, returned when t = 0.0f.</param>
+        /// <param name="b">The end Vector3, returned when t = 1.0f.</param>
         /// <param name="t">Value used to interpolate between a and b.</param>
         /// <returns>The interpolated Vector3.</returns>
-        static Vector3 LerpUnclamped(Vector3 a, Vector3 b, double t);
+        static Vector3 LerpUnclamped(Vector3 a, Vector3 b, float t);
         /// <summary>
         /// Moves a point current towards target.
         /// Similar to Lerp(), however, the function will ensure that the distance never
@@ -340,7 +341,7 @@ namespace SHADE
         /// <param name="target">The target position to move to.</param>
         /// <param name="maxDistanceDelta">Maximum distance moved per call.</param>
         /// <returns>Vector representing the moved point.</returns>
-        static Vector3 MoveTowards(Vector3 current, Vector3 target, double maxDistanceDelta);
+        static Vector3 MoveTowards(Vector3 current, Vector3 target, float maxDistanceDelta);
 
         /*-----------------------------------------------------------------------------*/
         /* Overloaded Operators                                                        */
@@ -374,7 +375,7 @@ namespace SHADE
         /// <param name="lhs">Vector3 to multiply with.</param>
         /// <param name="rhs">Scalar to multiply with.</param>
         /// <returns>The result of the scalar multiplication.</returns>
-        static Vector3 operator*(Vector3 lhs, double rhs);
+        static Vector3 operator*(Vector3 lhs, float rhs);
         /// <summary>
         /// Calculates the division of a Vector3 with a scalar value and returns 
         /// the result.
@@ -382,7 +383,7 @@ namespace SHADE
         /// <param name="lhs">Scalar to divide with.</param>
         /// <param name="rhs">Vector3 to divide with.</param>
         /// <returns>The result of the scalar division.</returns>
-        static Vector3 operator/(Vector3 lhs, double rhs);
+        static Vector3 operator/(Vector3 lhs, float rhs);
         /// <summary>
         /// Checks if two Vector3s are approximately equal. This is equivalent to 
         /// calling Vector3.IsNear() with default tolerance values.
diff --git a/SHADE_Managed/src/Utility/Convert.cxx b/SHADE_Managed/src/Utility/Convert.cxx
index 661eb3e4..4646194b 100644
--- a/SHADE_Managed/src/Utility/Convert.cxx
+++ b/SHADE_Managed/src/Utility/Convert.cxx
@@ -35,10 +35,7 @@ namespace SHADE
     /*---------------------------------------------------------------------------------*/
     SHVec3 Convert::ToNative(Vector3 vec)
     {
-        const double X = vec.x;
-        const double Y = vec.y;
-        const double Z = vec.z;
-        return SHVec3(X, Y, Z);
+        return SHVec3(vec.x, vec.y, vec.z);
     }
     Vector3 Convert::ToCLI(const SHVec3& vec)
     {
@@ -46,9 +43,7 @@ namespace SHADE
     }
     SHVec2 Convert::ToNative(Vector2 vec)
     {
-        const double X = vec.x;
-        const double Y = vec.y;
-        return SHVec2(X, Y);
+        return SHVec2(vec.x, vec.y);
     }
 
     Vector2 Convert::ToCLI(const SHVec2& vec)
@@ -56,6 +51,16 @@ namespace SHADE
         return Vector2(vec.x, vec.y);
     }
 
+    SHQuaternion Convert::ToNative(Quaternion quat)
+    {
+      return SHQuaternion{ quat.x, quat.y, quat.z, quat.w };
+    }
+
+    Quaternion   Convert::ToCLI(const SHQuaternion& quat)
+    {
+      return Quaternion{ quat.x, quat.y, quat.z, quat.w };
+    }
+
     /*---------------------------------------------------------------------------------*/
     /* String Conversions                                                              */
     /*---------------------------------------------------------------------------------*/
diff --git a/SHADE_Managed/src/Utility/Convert.hxx b/SHADE_Managed/src/Utility/Convert.hxx
index f04cbf4b..d694ca6a 100644
--- a/SHADE_Managed/src/Utility/Convert.hxx
+++ b/SHADE_Managed/src/Utility/Convert.hxx
@@ -18,10 +18,12 @@ of DigiPen Institute of Technology is prohibited.
 #include "ECS_Base/Entity/SHEntity.h"
 #include "Math/Vector/SHVec2.h"
 #include "Math/Vector/SHVec3.h"
+#include "Math/SHQuaternion.h"
 // Project Includes
 #include "Engine/Entity.hxx"
 #include "Math/Vector2.hxx"
 #include "Math/Vector3.hxx"
+#include "Math/Quaternion.hxx"
 
 namespace SHADE
 {
@@ -74,6 +76,18 @@ namespace SHADE
         /// <param name="vec">The native Vector2 to convert from.</param>
         /// <returns>Managed copy of a native Vector2.</returns>
         static Vector2 ToCLI(const SHVec2& vec);
+        /// <summary>
+        /// Converts from a managed Quaternion to a native Quaternion.
+        /// </summary>
+        /// <param name="quat">The managed Quaternion to convert from.</param>
+        /// <returns>Native copy of a managed Quaternion.</returns>
+        static SHQuaternion ToNative(Quaternion quat);
+        /// <summary>
+        /// Converts from a native Quaternion to a managed Quaternion.
+        /// </summary>
+        /// <param name="quat">The native Quaternion to convert from.</param>
+        /// <returns>Managed copy of a native Quaternion.</returns>
+        static Quaternion ToCLI(const SHQuaternion& quat);
 
         /*-----------------------------------------------------------------------------*/
         /* String Conversions                                                          */
